%global grub_arches x86_64 aarch64 loongarch64 %ix86

%define brand etersoft
%define Brand Etersoft
%define theme ximper
%define Theme Ximper
%define codename Alice
%define status %nil
%define status_en %nil
%define flavour %brand-%theme

%define design_graphics_abi_epoch 0
%define design_graphics_abi_major 12
%define design_graphics_abi_minor 0
%define design_graphics_abi_bugfix 0

%define data_cur_dir %_datadir/branding-data-current

%define _unpackaged_files_terminate_build 1

Name: branding-%flavour
Version: 0.9.2
Release: alt6
Url: https://ximperlinux.ru

%ifarch %ix86 x86_64
BuildRequires: cpio fonts-ttf-dejavu fonts-otf-abattis-cantarell
BuildRequires: design-bootloader-source >= 5.0-alt2 fribidi
%endif

BuildRequires(pre): rpm-macros-branding
BuildRequires: libalternatives-devel
BuildRequires: qt5-base-devel

BuildRequires: ImageMagick fontconfig bc

Source: branding.tar

Group: Graphics
Summary: System/Base
License: GPLv2+

%define distro_name Ximper Linux %version%status_en
%define distro_name_ru Ximper Linux %version%status

%description
Distro-specific packages for %distro_name.

%description -l ru_RU.UTF-8
Пакеты для дистрибутива %distro_name_ru.

%package bootloader
Group:   System/Configuration/Boot and Init
Summary: Graphical boot logo for grub2, lilo and syslinux
Summary(ru_RU.UTF-8): Тема для экрана выбора вариантов загрузки (lilo и syslinux)

License: GPLv2+

Requires(pre):    coreutils
Provides: design-bootloader-system-%theme = %EVR
Provides: design-bootloader-livecd-%theme = %EVR
Provides: design-bootloader-%theme = %EVR
Obsoletes: design-bootloader-system-%theme design-bootloader-livecd-%theme design-bootloader-livecd-%theme design-bootloader-%theme
%branding_add_conflicts %flavour bootloader

%define grub_normal white/light-blue
%define grub_high black/light-gray

%description bootloader
Here you find the graphical boot logo for %distro_name.
Suitable for both lilo and syslinux.

%description bootloader -l ru_RU.UTF-8
В данном пакете находится тема для экрана выбора вариантов загрузки (lilo и syslinux) 
для дистрибутива %distro_name_ru.

%package bootsplash
BuildArch: noarch
Summary: Theme for splash animations during bootup
License: Distributable
Group:  System/Configuration/Boot and Init
Provides: plymouth-theme-%theme plymouth(system-theme)
%define plymouth_theme bgrt
Requires: plymouth-theme-bgrt
Requires: plymouth-plugin-script
Requires: plymouth-plugin-label
Requires: fonts-ttf-dejavu
Requires(pre,postun): plymouth

%description bootsplash
This package contains graphics for boot process for %distro_name
(needs console splash screen enabled).

%description bootsplash -l ru_RU.UTF-8
В данном пакете находится тема для экрана загрузки для дистрибутива
%distro_name_ru.

%package alterator
Summary: Design for alterator for %distro_name
Summary(ru_RU.UTF-8): Тема для "Центра управления системой" и QT для дистрибутива %distro_name_ru
License: GPL
Group: System/Configuration/Other
BuildArch: noarch
Provides: branding-alt-%theme-browser-qt = %EVR
Provides: branding-altlinux-%theme-browser-qt = %EVR
Provides: alterator-icons design-alterator
Provides: design-alterator-%theme = %EVR
Provides: design-alterator-browser-%theme = %EVR

%branding_add_conflicts %flavour alterator
Obsoletes: design-alterator-server design-alterator-desktop design-altertor-browser-desktop  design-altertor-browser-server branding-altlinux-backup-server-alterator
Requires(post,preun): alternatives >= 0.2 alterator

%description alterator
Design for QT and web alterator for %distro_name.

%description alterator -l ru_RU.UTF-8
В данном пакете находится тема для "Центра управления системой" (Alterator)
и модулей библиотеки QT для дистрибутива %distro_name_ru.

%package graphics
Summary: Design for %distro_name
Summary(ru_RU.UTF-8): Тема для дистрибутива %distro_name_ru
License: Different licenses
Group: Graphics
BuildArch: noarch
Provides: design-graphics-%theme = %EVR
Provides: design-graphics = %design_graphics_abi_major.%design_graphics_abi_minor.%design_graphics_abi_bugfix
%branding_add_conflicts %flavour graphics

Requires(post,preun): alternatives >= 0.2


%description graphics
This package contains some graphics for %distro_name design.

%description graphics -l ru_RU.UTF-8
В данном пакете находится необходимые графические элементы для дистрибутива 
%distro_name_ru.

%define provide_list altlinux fedora redhat system altlinux
%define obsolete_list altlinux-release fedora-release redhat-release

%package release
BuildArch: noarch
Summary:  %distro_name release file
Summary(ru_RU.UTF-8): Описание дистрибутива %distro_name_ru
License:  GPL
Group:    System/Configuration/Other
Provides: %(for n in %provide_list; do echo -n "$n-release = %version-%release "; done) altlinux-release-%theme = %EVR
Obsoletes: %obsolete_list
%branding_add_conflicts %flavour release
Requires: alt-os-release

%description release
%distro_name release file.

%description release -l ru_RU.UTF-8
В данном пакете находится описание дистрибутива %distro_name_ru.

%package notes
BuildArch: noarch
Provides:  alt-license-theme = %version alt-notes-%theme
Obsoletes: alt-license-%theme alt-notes-%theme
Summary:   Distribution license and release notes
Summary(ru_RU.UTF-8): Лицензия и дополнительные сведения для дистрибутива %distro_name_ru
License:   Distributable
Group:     Documentation
%branding_add_conflicts %flavour notes

%description notes
Distribution license and release notes

%description notes -l ru_RU.UTF-8
В данном пакете находится лицензия и дополнительные сведения
для дистрибутива %distro_name_ru.

%package base-settings
BuildArch: noarch
Summary:   Base settings for %distro_name
License:   Distributable
Group:     Graphical desktop/Other
AutoReqProv: no
Requires: Kvantum gtk3-theme-adw-gtk3 kvantum-theme-kvlibadwaita
%branding_add_conflicts %flavour base-settings

%description base-settings
Base settings for %distro_name

%package gnome-settings
BuildArch: noarch
Summary:   GNOME settings for %distro_name
License:   Distributable
Group:     Graphical desktop/GNOME
AutoReqProv: no
%branding_add_conflicts %flavour gnome-settings

%description gnome-settings
GNOME settings for %distro_name

%package hyprland-settings
BuildArch: noarch
Summary:   Hyprland settings for %distro_name
License:   Distributable
Group:     Graphical desktop/Other
AutoReqProv: no
%branding_add_conflicts %flavour hyprland-settings

%description hyprland-settings
Hyprland settings for %distro_name

%package slideshow
Summary: Slideshow for %distro_name installer
Summary(ru_RU.UTF-8): Изображения для организации "слайдшоу" в установщике дистрибутива %distro_name_ru
License: Distributable
Group: System/Configuration/Other 
BuildArch: noarch
%branding_add_conflicts %flavour slideshow

%description slideshow
Slideshow for %distro_name installer.

%description slideshow -l ru_RU.UTF-8
В данном пакете находятся изображения для организации "слайдшоу" в установщике 
дистрибутива %distro_name_ru.

%package indexhtml
BuildArch: noarch
Summary:  Wiki for %distro_name
Summary(ru_RU.UTF-8): Wiki для дистрибутива %distro_name_ru
License:  distributable
Group:    System/Base
Provides: indexhtml indexhtml-%theme = %version indexhtml-Desktop = 1:5.0
Obsoletes: indexhtml-desktop indexhtml-Desktop
%branding_add_conflicts %flavour indexhtml

%description indexhtml
%distro_name wiki.

%description indexhtml -l ru_RU.UTF-8
В данном пакете содержится wiki для дистрибутива
%distro_name_ru.

%package backgrounds
Group: Graphics
Summary: Backgrounds for %distro_name
License: CC-BY-NC-SA-3.0+
BuildArch: noarch
%branding_add_conflicts %flavour backgrounds

%description backgrounds
This package contains backgrounds for %distro_name.


%prep
%setup -n branding

%build
autoconf
THEME=%theme NAME='%Brand %Theme' BRAND_FNAME='%brand' BRAND='%brand' STATUS_EN=%status_en STATUS=%status VERSION=%version PRODUCT_NAME_RU='%distro_name_ru' PRODUCT_NAME='%distro_name' CODENAME='%codename' ./configure
make

%install
%makeinstall
find %buildroot -name \*.in -delete

mkdir -p %buildroot/%_datadir/install3

mkdir -p %buildroot/%_datadir/glib-2.0/schemas
install gnome-settings-gschema/ximper-linux-gnome.gschema.override %buildroot%_datadir/glib-2.0/schemas/ximper-linux-gnome.gschema.override
install gnome-settings-gschema/ximper-linux-base.gschema.override %buildroot%_datadir/glib-2.0/schemas/ximper-linux-base.gschema.override

mkdir -p %buildroot%_sysconfdir/skel/.config/Kvantum
install  skel/skel/.config/Kvantum/kvantum.kvconfig %buildroot%_sysconfdir/skel/.config/Kvantum/kvantum.kvconfig

mkdir -p %buildroot%_sysconfdir/skel/.config/environment.d
install  skel/skel/.config/environment.d/qt.conf %buildroot%_sysconfdir/skel/.config/environment.d/qt.conf

#hyprland settings
for i in hypr kitty swaync waybar wofi wlogout ; do
mkdir -p %buildroot%_sysconfdir/skel/.config/$i
cp -r skel/skel/.config/$i %buildroot%_sysconfdir/skel/.config/
done

mkdir -p %buildroot%_sysconfdir/ximperdistro/
cp -r configs/hyprland %buildroot%_sysconfdir/ximperdistro/

install pixmaps/ximperlinux.svg %buildroot%_pixmapsdir/ximperlinux.svg

#backgrounds
install -pD -m644 -t %buildroot%_datadir/wallpapers/ximper/ ximperwallpapers/*
./imgtognome.sh %buildroot%_datadir/wallpapers/ximper/
mkdir -p %buildroot%_datadir/gnome-background-properties
mv %buildroot%_datadir/wallpapers/ximper/ximper.xml %buildroot%_datadir/gnome-background-properties/

#bootloader
%ifarch %ix86 x86_64
%pre bootloader
[ -s /boot/splash/%theme ] && rm -fr  /boot/splash/%theme ||:
%endif

%post bootloader
[ "$1" -eq 1 ] || exit 0
. shell-config
shell_config_set /etc/sysconfig/grub2 GRUB_THEME /boot/grub/themes/%theme/theme.txt
#shell_config_set /etc/sysconfig/grub2 GRUB_THEME /boot/grub/themes/%theme
shell_config_set /etc/sysconfig/grub2 GRUB_COLOR_NORMAL %grub_normal
shell_config_set /etc/sysconfig/grub2 GRUB_COLOR_HIGHLIGHT %grub_high

%ifarch %grub_arches
%files bootloader
/boot/grub/themes/%theme
%else
%exclude /boot/grub/themes/%theme
%endif

#bootsplash
%post bootsplash
sed -i "s/Theme=.*/Theme=%plymouth_theme/" /etc/plymouth/plymouthd.conf ||:

#notes
%post notes
if ! [ -e %_datadir/alt-notes/license.all.html ]; then
	cp -a %data_cur_dir/alt-notes/license.*.html %_datadir/alt-notes/
fi

%files alterator
%config %_altdir/*.rcc
/usr/share/alterator-browser-qt/design/*.rcc
/usr/share/alterator/design/*

%files graphics
%config /etc/alternatives/packages.d/%name-graphics
%_datadir/design
%_pixmapsdir/ximperlinux.svg

%files backgrounds
%_datadir/wallpapers/ximper
%_datadir/gnome-background-properties/ximper.xml

%files bootsplash
%_datadir/plymouth/themes/%theme/*
%_pixmapsdir/system-logo.png

%files release
%_sysconfdir/*-release
%_prefix/lib/os-release
%_sysconfdir/buildreqs/packages/ignore.d/*

%files notes
%dir %data_cur_dir
%data_cur_dir/alt-notes
%_datadir/alt-notes/livecd-*
%_datadir/alt-notes/release-notes.*
%ghost %config(noreplace) %_datadir/alt-notes/license.*.html

%files base-settings
%_sysconfdir/skel/.config/Kvantum/kvantum.kvconfig
%_datadir/glib-2.0/schemas/ximper-linux-base.gschema.override

%files gnome-settings
%_datadir/glib-2.0/schemas/ximper-linux-gnome.gschema.override
%_sysconfdir/skel/.config/environment.d/qt.conf

%files hyprland-settings
%_sysconfdir/skel/.config/hypr
%_sysconfdir/skel/.config/kitty
%_sysconfdir/skel/.config/swaync
%_sysconfdir/skel/.config/waybar
%_sysconfdir/skel/.config/wofi
%_sysconfdir/skel/.config/wlogout
%_sysconfdir/ximperdistro/hyprland

%files slideshow
/etc/alterator/slideshow.conf
/usr/share/install2/slideshow

%files indexhtml
%_desktopdir/ximper-wiki.desktop

%changelog
* Mon Sep 23 2024 Kirill Unitsaev <fiersik@altlinux.org> 0.9.2-alt6
- drop outdated code (ALT bug 51347)

* Tue Sep 03 2024 Roman Alifanov <ximper@altlinux.org> 0.9.2-alt5
- gnome-settings: add requires
- gnome-settings: replaced kvantum theme

* Sun Sep 01 2024 Roman Alifanov <ximper@altlinux.org> 0.9.2-alt4
- modification of the color palette
- update the GRUB theme

* Thu Aug 22 2024 Kirill Unitsaev <fiersik@altlinux.org> 0.9.2-alt3
- added new wallpaper

* Sun Aug 18 2024 Roman Alifanov <ximper@altlinux.org> 0.9.2-alt2
- update the GRUB and installer theme
- fixed an issue that caused the indicator of an open application to overlap with its icon

* Tue Apr 23 2024 Roman Alifanov <ximper@altlinux.org> 0.9.2-alt1
- drop gfxboot for syslinux

* Wed Jan 17 2024 Roman Alifanov <ximper@altlinux.org> 0.9.1-alt1
- gnome-settings: set some nautilus settings

* Sat Oct 07 2023 Roman Alifanov <ximper@altlinux.org> 0.9-alt1
- gnome-settings: dash-to-dock extension: set click-action

* Tue Oct 03 2023 Roman Alifanov <ximper@altlinux.org> 0.8.5-alt1
- gnome-settings: set kgx as default terminal
- gnome-settings: set favorite-apps

* Sun Sep 17 2023 Roman Alifanov <ximper@altlinux.org> 0.8.1-alt1
- changed default wallpaper
- added new wallpapers

* Wed Aug 30 2023 Roman Alifanov <ximper@altlinux.org> 0.8-alt1
- Initial build for Sisyphus. (Forked from branding-alt-server)
